// Generated by CoffeeScript 1.10.0
var findNpm, fs, log, path, requireLocal, resolveNpm;

fs = require('fs');

path = require('path');

log = require('../log');

requireLocal = require('../utils').requireLocal;

findNpm = function(url) {
  var err, error;
  try {
    return path.relative(process.cwd(), require.resolve(url));
  } catch (error) {
    err = error;
    return path.relative(process.cwd(), require.resolve(url));
  }
};

resolveNpm = (function() {
  var cache;
  cache = {};
  return function(url, file, cb) {
    var e, error, newPath;
    if (cache[url] != null) {
      return cb({
        file: cache[url]
      });
    }
    try {
      newPath = findNpm(url);
      cache[url] = newPath;
      return cb({
        file: newPath
      });
    } catch (error) {
      e = error;
      cache[url] = url;
      return cb({
        file: url
      });
    }
  };
})();

module.exports = function(src, dst, cb) {
  var sass;
  sass = requireLocal('node-sass');
  return sass.render({
    file: src,
    includePaths: [path.join(process.cwd(), 'node_modules')],
    outputStyle: 'nested'
  }, function(err, res) {
    if (err != null) {
      throw err;
    }
    return fs.writeFile(dst, res.css, function(err) {
      if (err != null) {
        throw err;
      }
      return cb(null, true);
    });
  });
};
